package org.coderu.core.impl.explorer.helpers;

import static org.coderu.common.utils.CollectionUtils.*;

import java.util.Collection;
import java.util.LinkedList;

import org.coderu.common.utils.FunctionFactory;
import org.coderu.core.api.Packagge;
import org.coderu.core.impl.common.types.PackageDependency;
import org.coderu.core.impl.common.types.PackageName;
import org.coderu.core.impl.common.types.PackageWithDependencies;


public final class Packages2AccessRights {

    public static Collection<PackageDependency> javaPackages2AccessRights(
        final Collection<PackageWithDependencies> javaPackages) {

        final Collection<PackageDependency> packageDependencies = new LinkedList<PackageDependency>();
        for (PackageWithDependencies from : javaPackages) {
            for (PackageWithDependencies to : from.getThird()) {
                final PackageDependency pd = 
                    new PackageDependency(toPackageId(from.getFirst()), toPackageId(to.getFirst()));
                
                packageDependencies.add(pd);
            }
        }
        return packageDependencies;
    }

    public static Collection<PackageName> javaPackages2packageIds(
        final Collection<PackageWithDependencies> javaPackages) {

        return transform(javaPackages, 
            FunctionFactory.concat(PackageWithDependencies.TO_PACKAGE,PackageName.FROM_API));
    }

    private static PackageName toPackageId(Packagge javaPackage) {

        return PackageName.FROM_API.apply(javaPackage);
    }

    private Packages2AccessRights() {}
}
